//******************************************************************************
// PnCMenu.sc
// Contains the script which runs our point and click menu. 
//******************************************************************************
(include "sci.sh")(include "game.sh")                               (script 950)
//******************************************************************************
(use "main")(use "controls")(use "cycle")(use "game")(use "feature")
(use "obj")
//******************************************************************************
(local

)
//******************************************************************************	
(instance public PnCMenu of Rgn
(properties)
  (method (init)
  (super:init())

  (self:setScript(PnCMenuScript))

  (quitIcon:init())
  (saveIcon:init())
  (loadIcon:init())
  (helpIcon:init())
  (menuIcon:init()) 
   
  (if(DoSound(sndSET_SOUND))(mute:loop(0)init())) // mute sound
  (else(mute:loop(1)init()))                      // unmute sound   
  )// end init method
)// end public Instance
//***********************************************************************


//***********************************************************************
(instance PnCMenuScript of Script
(properties)
  (method (doit)
  (super:doit())

  )// end method

  (method (handleEvent pEvent)
  (super:handleEvent(pEvent))
    (if(==(send pEvent:type())evMOUSEBUTTON)
      (if(not(& (send pEvent:modifiers) emRIGHT_BUTTON))
        (if((> (send pEvent:x) (mute:nsLeft))and //  Toggle Sound
        (< (send pEvent:x) (mute:nsRight))and // you can always mute,
        (> (send pEvent:y) (mute:nsTop))and   // even during programcontrol
        (< (send pEvent:y) (mute:nsBottom))) 
        (send pEvent:type(evMOUSEBUTTON) claimed(TRUE))
        ToggleSound()
        (if(DoSound(sndSET_SOUND))(mute:loop(0)))
        (else(mute:loop(1)))
        )	
       (if(== gProgramControl TRUE)(send pEvent:claimed(TRUE)))// do nuthin 
       (else
//***********************************************************************
         (if((> (send pEvent:x) (loadIcon:nsLeft))and
	         (< (send pEvent:x) (loadIcon:nsRight))and
	         (> (send pEvent:y) (loadIcon:nsTop))and
	         (< (send pEvent:y) (loadIcon:nsBottom)))
             (send pEvent:claimed(TRUE))
             (loadIcon:setScript(dotheload))
		 )
(else	
         (if((> (send pEvent:x) (saveIcon:nsLeft))and
	         (< (send pEvent:x) (saveIcon:nsRight))and
	         (> (send pEvent:y) (saveIcon:nsTop))and
	         (< (send pEvent:y) (saveIcon:nsBottom)))
             (send pEvent:claimed(TRUE))
	         (saveIcon:setScript(dothesave))
       	 )
(else	
         (if((> (send pEvent:x) (quitIcon:nsLeft))and
	         (< (send pEvent:x) (quitIcon:nsRight))and
	         (> (send pEvent:y) (quitIcon:nsTop))and
	         (< (send pEvent:y) (quitIcon:nsBottom)))
             (send pEvent:claimed(TRUE))
             (quitIcon:setScript(dothequit))
		 )
(else	
         (if((> (send pEvent:x) (helpIcon:nsLeft))and
	         (< (send pEvent:x) (helpIcon:nsRight))and
	         (> (send pEvent:y) (helpIcon:nsTop))and
	         (< (send pEvent:y) (helpIcon:nsBottom)))
             (send pEvent:claimed(TRUE))
             (helpIcon:setScript(dothehelp))
		 )
(else	
         (if((> (send pEvent:x) (menuIcon:nsLeft))and
	         (< (send pEvent:x) (menuIcon:nsRight))and
	         (> (send pEvent:y) (menuIcon:nsTop))and
	         (< (send pEvent:y) (menuIcon:nsBottom)))
             (send pEvent:claimed(TRUE))
             (menuIcon:setScript(dothemenu))
		 )
//****************************************************************************
)))	)
//***********************************************************************       	
	   ) // end no program control
     ) // end if right button 
    ) // end if mousebutton
  )// end method
)// end instance
//*********************************************

(instance mute of Prop(properties x 155 y 178 view 950 loop 0 cel 0))
(instance loadIcon of Prop(properties x 245 y 178 view 950 loop 0 cel 2))
(instance saveIcon of Prop(properties x 215 y 178 view 950 loop 0 cel 3))
(instance quitIcon of Prop(properties x 275 y 178 view 950 loop 0 cel 1))
(instance menuIcon of Prop(properties x 185 y 178 view 950 loop 0 cel 5))
(instance helpIcon of Prop(properties x 305 y 178 view 950 loop 0 cel 4))
//*********************************************
(instance dothequit of Script
(properties)
  (method (changeState newState)
   = state newState
   (switch (state)
        (case 0 (quitIcon:loop(1)) = cycles 3)
        (case 1 (if(Print(950 0 #title "Quit"  #font gDefaultFont #button " Quit " 1 #button " Oops " 0))
        		= cycles 5
                )
                (else (quitIcon:loop(0)))
	   )
	   (case 2 Print(950 1)
                = gQuitGame TRUE
       )
  )
   )
)

(instance dothesave of Script
(properties)
  (method (changeState newState)
   = state newState
   (switch (state)
      (case 0 (saveIcon:loop(1))
      	      = cycles 3)
      (case 1
           (saveIcon:loop(0))(send gGame:save())
		   = cycles 1
	  )
	  (case 2 (saveIcon:loop(0))
	  	)
    )
   )
)
//*************************************
(instance dothemenu of Script
(properties)
  (method (changeState newState)
   = state newState
   (switch (state)
      (case 0 (menuIcon:loop(1))
      	      (send gTheMusic:
			  prevSignal(0)
			  fade(2))
      	      = cycles 3)
      (case 1
           // bring up menu buttons
           = backToMenu TRUE
           
	  )
	  (case 2 (saveIcon:loop(0))
	  	)
    )
   )
)
//**************************************


(instance dotheload of Script
(properties)
  (method (changeState newState)
   = state newState
   (switch (state)
       (case 0 (loadIcon:loop(1))
      	      = cycles 3)
       (case 1
           (send gGame:restore())
		   = cycles 1
	   )
	   (case 2 (loadIcon:loop(0)))
	  )
   )
)

(instance dothehelp of Script
(properties)
  (method (changeState newState)
   = state newState
   (switch (state)
       (case 0 (helpIcon:loop(1))
      	      = cycles 3)
       (case 1
          (switch(gRoomNumber)
          	(default 
          		
          		    Print("Winter Wonderland\n\n       Version 1.0\n             2012\n\n       Shane Cloud")
          		    Print("      The idea here:\nUnscramble the puzzle.")
          		    Print("      There is one blank space.\n\nYou can maneuver the puzzle pieces by clicking on the ones next to the blank. The puzzle tile will then shift.\n\nRepeat this process until you have unscrambled the puzzle.")
			)
		  )
          
          
          
          
       = cycles 3   
	   )
	   (case 2 (helpIcon:loop(0)))
	  )
   )
)